/*
    Klat - A LaTeX editor for KDE
    
    Copyright (C) 2002-2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef KLAT_H

#define KLAT_H

#include "klatexecconfig.h"
#include <kdockwidget.h>

class KlatEditTab;
class KlatToolTab;
class KlatOutputTab;
class KPopupMenu;
class KConfig;
class KRecentFilesAction;
class KURL;

class Klat : public KDockMainWindow
{
	Q_OBJECT
public:
	Klat();
	~Klat();
	void openCommandLineFile(const QString &fname);
public slots:
	void slotCursorPositionChanged(int line,int col);
	void slotLaTeXCodeChanged(const QString &s);
	void slotLaTeXCodeClear();
	void slotFileReferenced(const KURL &url);
private slots:
	void showAboutApplication();
	void slotExecuteSettings();
	void slotExecMenuItemClicked(int);
	void slotDummy();
	void slotViewToggleTools();
	void slotViewToggleOutput();
	void slotViewCloseTools();
	void slotViewCloseOutput();
	void slotUpdateViewMenu();
private:
	void createWindows();
	void createMenuBarAndToolbarAndStatusBar();
	void buildExecMenu();
	bool queryClose();

	KlatEditTab *edittab;
	KlatToolTab *tooltab;
	KlatOutputTab *outputtab;
	KDockWidget *toolDock,*outputDock;

	KlatExecConfig execConfig;
	KPopupMenu *execMenu;

	KConfig *config;
	KRecentFilesAction *recentFiles;
	KAction *viewToolsAction,*viewOutputAction;
};

#endif // KLAT_H

