/*
    Klat - A LaTeX editor for KDE
    
    Copyright (C) 2002-2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef KLATEDITCOMMANDDLGIMPL_H

#define KLATEDITCOMMANDDLGIMPL_H

#include "klateditcommanddlg.h"
#include <kshortcut.h>
#include <qstring.h>

class KlatEditCommandDlgImpl : public KlatEditCommandDlg
{
	Q_OBJECT
public:
	KlatEditCommandDlgImpl(QWidget *parent,char *name = 0);
	~KlatEditCommandDlgImpl();
	
	void setMenuName(const QString &m)				{ menuname = m; }
	void setCommandLine(const QString &c)				{ cmdLine = c; }
	void setSaveFirst(bool s)					{ savefirst = s; }
	void setShortcut(const KShortcut &shortcut)			{ cut = shortcut; }

	int exec();
	
	QString menuName() const					{ return menuname; }
	QString commandLine() const					{ return cmdLine; }
	bool saveFirst() const						{ return savefirst; }
	KShortcut shortcut() const					{ return cut; }
private slots:
	void slotOkButtonPressed();
	void slotChangeShortcut(const KShortcut &newshortcut);
	void slotClearShortcut();
private:
	QString menuname,cmdLine;
	bool savefirst;
	KShortcut cut;
};

#endif // KLATEDITCOMMANDDLGIMPL_H
