/*
    Klat - A LaTeX editor for KDE
    
    Copyright (C) 2002-2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef KLATEXECCONFIG_H

#define KLATEXECCONFIG_H

#include <qstring.h>
#include <list>
#include <kshortcut.h>

class KConfig;

class KlatExecMenuEntry
{
public:
	KlatExecMenuEntry(const QString &menuname,const QString &command,bool savefirst,const KShortcut &shortcut)	{ mname = menuname; cmd = command; save = savefirst; cut = shortcut; }
	KlatExecMenuEntry(const KlatExecMenuEntry &src)				{ mname = src.mname; cmd = src.cmd; save = src.save; cut = src.cut; }
	QString menuName() const						{ return mname; }
	QString commandLine() const						{ return cmd; }
	bool saveFirst() const							{ return save; }
	KShortcut shortcut() const						{ return cut; }
private:
	QString mname,cmd;
	bool save;
	KShortcut cut;
};

class KlatExecConfig
{
public:
	KlatExecConfig();
	~KlatExecConfig();
	void read(KConfig *cfg);
	void write(KConfig *cfg);
	bool gotoFirstEntry();
	bool gotoNextEntry();
	bool gotoEntry(int index);
	QString menuName();
	QString commandLine();
	bool saveFirst();
	KShortcut shortcut();
	KlatExecMenuEntry entry();
	void insertAfterCurrent(const KlatExecMenuEntry &m);
	void deleteCurrent();
	void changeCurrent(const KlatExecMenuEntry &m);
private:
	std::list<KlatExecMenuEntry> execEntries;
	std::list<KlatExecMenuEntry>::iterator it;
};

#endif // KLATEXECCONFIG_H
