/*
    Klat - A LaTeX editor for KDE
    
    Copyright (C) 2002-2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef KLATOUTPUTTAB_H

#define KLATOUTPUTTAB_H

#include <qtabwidget.h>
#include <sys/types.h>
#include <unistd.h>

class KProcess;
class KEdit;
class QString;
class QMainWindow;

class KlatOutputTab : public QTabWidget
{
	Q_OBJECT
public:
	KlatOutputTab(QWidget *parent);
	~KlatOutputTab();
	void newProcess(pid_t newpid,const QString &cmd);
	void finishedProcess(pid_t procpid);
public slots:
	void slotAddStdout(KProcess *proc,char *buffer,int buflen);
	void slotAddStderr(KProcess *proc,char *buffer,int buflen);
private:
	static void addTextToEditWidget(KEdit *w,const char *buffer,int buflen);
	
	KEdit *out,*err;
	pid_t currentpid;
};

#endif // KLATOUTPUTTAB_H
