/*
    Klat - A LaTeX editor for KDE
    
    Copyright (C) 2002-2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "klat.h"
#include <kapplication.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>

static KCmdLineOptions options[] =
{
	{ "+[file(s)]","Document(s) to open.", 0 },
	{ 0, 0, 0}
};

int main(int argc,char *argv[])
{
	KAboutData aboutinfo("klat","klat",VERSION,"A LaTeX editor for KDE",KAboutData::License_GPL,
			"Klat - A LaTeX editor for KDE\n"
			"Copyright (C) 2002-2004  Jori Liesenborgs\n\n"
			"This program is free software; you can redistribute it and/or modify\n"
    			"it under the terms of the GNU General Public License as published by\n"
    			"the Free Software Foundation; either version 2 of the License,\n" 
			"or (at your option) any later version.\n\n"
			"This program is distributed in the hope that it will be useful,\n"
			"but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
    			"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
    			"GNU General Public License for more details.\n\n"
    			"You should have received a copy of the GNU General Public License\n"
    			"along with this program; if not, write to the Free Software\n"
    			"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n",
			"\nFor Mieke! x   :-)\n","http://lumumba.luc.ac.be/jori/klat",
			"jori@lumumba.luc.ac.be");
	aboutinfo.addAuthor("Jori Liesenborgs");
	aboutinfo.addAuthor("Brachet Pascal, author of Kile (from which I took the mathematical symbols)");

	KCmdLineArgs::init(argc,argv,&aboutinfo);
	KCmdLineArgs::addCmdLineOptions(options);

	KApplication app;
	KCmdLineArgs *args;
	Klat *klat;
	int i,status;
	
	klat = new Klat();
	
	args = KCmdLineArgs::parsedArgs();
	for (i = 0 ; i < args->count() ; i++)
		klat->openCommandLineFile(args->arg(i));
	
	app.setMainWidget(klat);
	status = app.exec();
	args->clear();
	return status;
}
